#pragma once

#include <FL/fl_file_chooser.H>						//for getting input filename
#include <CGAL/Polyhedron_incremental_builder_3.h>	//standard builder

#include "Def.h"

// A modifier creating a triangle with the incremental builder.
template <class HDS>
class OBJ_Reader : public CGAL::Modifier_base<HDS> {
public:
    OBJ_Reader() {}
    void operator()( HDS& hds) 
	{
		char buf[200];
		char* filename = fl_file_chooser("Select file to view:", "*.obj", "");
		if(filename == 0)	{printf("no such file, exit.\n"); exit(0);}
		printf("file name = %s \n", filename);

		int nVert = 0, nTri = 0;
		ifstream infile;
		infile.open(filename);
		while(!infile.eof())
		{
			infile.getline(buf, 200, '\n');
			if(buf[0] == 'v' && buf[1] == ' ')	nVert++;
			if(buf[0] == 'f' && buf[1] == ' ')	nTri++;
		}
		infile.clear();		infile.close();
		printf("Mesh file with %d vertices and %d triangles.\n", nVert, nTri);
        
		// Postcondition: `hds' is a valid polyhedral surface.
        CGAL::Polyhedron_incremental_builder_3<HDS> B( hds, true);

		infile.open(filename);
		// Please inseart your code to put the read vertex/face info. into the Polyhedron B

		while(!infile.eof())
		{
			infile.getline(buf, 200, '\n');
			if(buf[0] == 'v' && buf[1] == ' ')
			{
				float x,y,z;
				sscanf(buf, "v %f %f %f", &x, &y, &z);
			}
			if(buf[0] == 'f' && buf[1] == ' ')
			{
				int i1, i2, i3;
				sscanf(buf, "f %d %d %d", &i1, &i2, &i3);
			}
		}
		infile.close();
    }
};


void Write_OBJ(Polyhedron &P)
{
	char* out_filename = fl_file_chooser("Specify filename to save:", "*.obj", "");
	ofstream out(out_filename);
    // Please write the vertex/face info. in the Polyhedron P into the ofstream out
}